<?php
class SimpleMusic extends Plugin
	{
	private $isEnabled;
	private $songlist;
	private $url;
	private $force_music;
	private $shutit;
	private $downbaby;

	function loadMusic(&$command)
		{
		$settings = $this->Aseco->xml_parser->parseXML('music_server.xml');
		$settings = $settings['SETTINGS'];
		$this->isEnabled = $settings['MUSIC_ON'][0];
		$this->songlist = $settings['SONG_FILES'][0]['SONG'];
		$this->url = $settings['MUSIC_SERVER'][0];
		$this->force_music = (bool)$settings['FORCE_MUSIC'][0];
		$this->Aseco->console('SimpleMusic plugin initialized.');
		$this->Aseco->client->query('ChatSendServerMessage', '$z$b$s$w$777SimpleMusic plugin initialized.$z');
		$junk = $this->Aseco->client->getResponse();
		return;
		}

	function playMusic(&$command)
		{
		shuffle($this->songlist);
		$random_song = $this->url . $this->songlist[array_rand($this->songlist)];
		if($this->isEnabled == 'yes')
		{
		$this->Aseco->client->query('SetForcedMusic', $this->force_music, $random_song);
		$junk = $this->Aseco->client->getResponse();
		unset($junk);
		}
	}

	function stopTheMusic(&$command)
		{
		$this->shutit = (bool)null;
		$this->downbaby = "";
		$this->Aseco->client->query('SetForcedMusic', $this->shutit, $this->downbaby);
		$junk = $this->Aseco->client->getResponse();
		$this->isEnabled = 'no';
		$this->Aseco->client->query('ChatSendServerMessage', '>>> $z$f66Admin stopped the music server.$z');
		$junk = $this->Aseco->client->getResponse();
		unset($junk);
		return;
		}

	function init()
		{
		$adminplugin = $this->Aseco->getPlugin('Admin');
		if ( isset($adminplugin) )
		{
		$adminplugin->addButton('Stop Music', 'Stops the music server on the next map.', 'stopMusicAP', $this);
		$adminplugin->addButton('Reload Music', 'Reloads/Restarts the music server.', 'loadMusicAP', $this);
		}
	}

	function stopMusicAP($clickvalue, $window, $player)		// called from admin panel button
		{
		$cmd['author'] = $player;
		$this->stopTheMusic($cmd);
		}  

	function loadMusicAP($clickvalue, $window, $player)		// called from admin panel button
		{
		$cmd['author'] = $player;
		$this->loadMusic($cmd);
		} 
	}
	
$_PLUGIN = new SimpleMusic();
$_PLUGIN->setAuthor('CavalierDeVache');
$_PLUGIN->setVersion(1.7);
$_PLUGIN->setDescription('Sends custom music to racers');
$_PLUGIN->addChatCommand('admin reloadmusic', 'loadMusic', 'Reload songlist and settings from music_server.xml');
$_PLUGIN->addChatCommand('admin stopmusic', 'stopTheMusic', 'Stops the music server until the next reload or restart');
$_PLUGIN->addEvent('onStartup', 'loadMusic');
$_PLUGIN->addEvent('onEndRound', 'playMusic');
$_PLUGIN->addEvent('onSync', 'init');
$_PLUGIN->setWebsite('http://www.tm-slowpokes.com');
?>
